标签:
Problem Description
You’re giving a party in the garden of your villa by the sea. The party is a huge success, and everyone is here. It’s a warm, sunny evening, and a soothing wind sends fresh, salty air from the sea. The evening is progressing just as you had imagined. It could
be the perfect end of a beautiful day.
But nothing ever is perfect. One of your guests works in weather forecasting. He suddenly yells, “I know that breeze! It means its going to rain heavily in just a few minutes!” Your guests all wear their best dresses and really would not like to get wet, hence
they stand terrified when hearing the bad news.
You have prepared a few umbrellas which can protect a few of your guests. The umbrellas are small, and since your guests are all slightly snobbish, no guest will share an umbrella with other guests. The umbrellas are spread across your (gigantic) garden, just
like your guests. To complicate matters even more, some of your guests can’t run as fast as the others.
Can you help your guests so that as many as possible find an umbrella before it starts to pour?
Given the positions and speeds of all your guests, the positions of the umbrellas, and the time until it starts to rain, find out how many of your guests can at most reach an umbrella. Two guests do not want to share an umbrella, however.
Input
The input starts with a line containing a single integer, the number of test cases.
Each test case starts with a line containing the time t in minutes until it will start to rain (1 <=t <= 5). The next line contains the number of guests m (1 <= m <= 3000), followed by m lines containing x- and y-coordinates as well as the speed si in units
per minute (1 <= si <= 3000) of the guest as integers, separated by spaces. After the guests, a single line contains n (1 <= n <= 3000), the number of umbrellas, followed by n lines containing the integer coordinates of each umbrella, separated
by a space.
The absolute value of all coordinates is less than 10000.
Output
For each test case, write a line containing “Scenario #i:”, where i is the number of the test case starting at 1. Then, write a single line that contains the number of guests that can at most reach an umbrella before it starts to rain. Terminate every test
case with a blank line.
Sample Input
2
1
2
1 0 3
3 0 3
2
4 0
6 0
1
2
1 1 2
3 3 2
2
2 2
4 4
Sample Output
Scenario #1:
2
Scenario #2:
2
题意:找出人和伞之间的关系就得n^2的时间,匈牙利算法果断超时。
H-K算法复杂度o(sqrt(n)E).
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<vector>
#include<string>
#include<iostream>
#include<queue>
#include<cmath>
#include<map>
#include<stack>
#include<set>
using namespace std;
#define REPF( i , a , b ) for ( int i = a ; i <= b ; ++ i )
#define REP( i , n ) for ( int i = 0 ; i < n ; ++ i )
#define CLEAR( a , x ) memset ( a , x , sizeof a )
typedef long long LL;
typedef pair<int,int>pil;
const int maxn=3000+100;
int head[maxn];
int mx[maxn],my[maxn];
int dx[maxn],dy[maxn];
int used[maxn];
struct Node{
int x,y;
int s;
}e[maxn];
struct node{
int x,y;
}pos[maxn];
struct edge{
int u,v;
int next;
}ee[maxn*maxn];
int cas,t,n,m,cnt,num,dis;
bool SearchP()
{
queue<int>q;
dis=0x3f3f3f3f;
CLEAR(dx,-1);
CLEAR(dy,-1);
REPF(i,1,n)
if(mx[i]==-1)
{
q.push(i);
dx[i]=0;
}
while(!q.empty())
{
int u=q.front();
q.pop();
if(dx[u]>dis) break;
for(int i=head[u];i!=-1;i=ee[i].next)
{
int v=ee[i].v;
if(dy[v]==-1)
{
dy[v]=dx[u]+1;
if(my[v]==-1) dis=dy[v];
else
{
dx[my[v]]=dy[v]+1;
q.push(my[v]);
}
}
}
}
return dis!=0x3f3f3f3f;
}
bool dfs(int u)
{
for(int i=head[u];i!=-1;i=ee[i].next)
{
int v=ee[i].v;
if(!used[v]&&dy[v]==dx[u]+1)
{
used[v]=1;
if(my[v]!=-1&&dy[v]==dis) continue;
if(my[v]==-1||dfs(my[v]))
{
my[v]=u;
mx[u]=v;
return true;
}
}
}
return false;
}
void work()
{
int res=0;
CLEAR(mx,-1);
CLEAR(my,-1);
while(SearchP())
{
CLEAR(used,0);
REPF(i,1,n)
if(mx[i]==-1&&dfs(i)) res++;
}
printf("Scenario #%d:\n%d\n\n",++num,res);
}
bool ok(int i,int j)
{
double d=sqrt((double)(e[i].x-pos[j].x)*(e[i].x-pos[j].x)+(double)(e[i].y-pos[j].y)*(e[i].y-pos[j].y));
return d/e[i].s<=t;
}
void addedge(int u,int v)
{
ee[cnt].u=u;ee[cnt].v=v;
ee[cnt].next=head[u];
head[u]=cnt++;
}
int main()
{
int x,y,w;
num=0;
scanf("%d",&cas);
while(cas--)
{
CLEAR(head,-1);cnt=0;
scanf("%d%d",&t,&n);
REPF(i,1,n)
scanf("%d%d%d",&e[i].x,&e[i].y,&e[i].s);
scanf("%d",&m);
REPF(i,1,m)
{
scanf("%d%d",&pos[i].x,&pos[i].y);
REPF(j,1,n)
if(ok(j,i)) addedge(j,i);
}
work();
}
return 0;
}
二分图(H-K算法)
标签:
原文地址:http://blog.csdn.net/u013582254/article/details/43467173